=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2008-11-21 16:43:53 +0000
+++ bzrlib/tests/blackbox/test_log.py	2008-12-04 19:59:34 +0000
@@ -140,12 +140,36 @@
         self.assertTrue('branch nick: branch2\n' in log)
         self.assertTrue('branch nick: branch1\n' not in log)
 
+    def test_log_nonexistent_revno(self):
+        self._prepare()
+        (out, err) = self.run_bzr_error(args="log -r 1234",
+            error_regexes=["bzr: ERROR: Requested revision: '1234' "
+                "does not exist in branch:"])
+
+    def test_log_nonexistent_dotted_revno(self):
+        self._prepare()
+        (out, err) = self.run_bzr_error(args="log -r 123.123",
+            error_regexes=["bzr: ERROR: Requested revision: '123.123' "
+                "does not exist in branch:"])
+
     def test_log_change_revno(self):
         self._prepare()
         expected_log = self.run_bzr("log -r 1")[0]
         log = self.run_bzr("log -c 1")[0]
         self.assertEqualDiff(expected_log, log)
 
+    def test_log_change_nonexistent_revno(self):
+        self._prepare()
+        (out, err) = self.run_bzr_error(args="log -c 1234",
+            error_regexes=["bzr: ERROR: Requested revision: '1234' "
+                "does not exist in branch:"])
+
+    def test_log_change_nonexistent_dotted_revno(self):
+        self._prepare()
+        (out, err) = self.run_bzr_error(args="log -c 123.123",
+            error_regexes=["bzr: ERROR: Requested revision: '123.123' "
+                "does not exist in branch:"])
+
     def test_log_change_single_revno(self):
         self._prepare()
         self.run_bzr_error('bzr: ERROR: Option --change does not'

=== modified file 'bzrlib/tests/test_revisionspec.py'
--- bzrlib/tests/test_revisionspec.py	2008-08-28 13:41:15 +0000
+++ bzrlib/tests/test_revisionspec.py	2008-12-04 19:09:52 +0000
@@ -176,6 +176,7 @@
 
     def test_dotted_decimal(self):
         self.assertInHistoryIs(None, 'alt_r2', '1.1.1')
+        self.assertInvalid('1.1.123')
 
     def test_negative_int(self):
         self.assertInHistoryIs(2, 'r2', '-1')

